
extern char hware_outdat;

void set_hardware_tx_frequency(void)
{
switch (ui.soundcard_radio)
  {
  case SOUNDCARD_RADIO_WSE:
  wse_tx_freq_control();
  break;
  }
}

void hware_hand_key(void)
{
int i;
// This routine is called from the rx_input_thread.
// It is responsible for reading the hardware and setting
// hand_key to TRUE or FALSE depending on whether the hand key
// is depressed or not.
if( wse.parport != 0 && allow_wse_parport)
  {
  i=lir_inb(wse_parport_status)&HWARE_MORSE_KEY;
  if(i==0)
    {
    hand_key=TRUE;
    }
  else
    {
    hand_key=FALSE;
    }
  }
}

void hware_set_rxtx(int state)
{
if( wse.parport != 0 && allow_wse_parport)
  {
  lir_mutex_lock();
  if(state == TRUE)
    {
    hware_outdat&=-1-HWARE_RXTX;
    }
  else
    {
    hware_outdat|=HWARE_RXTX;
    }
  lir_mutex_unlock();
  lir_outb(hware_outdat,wse_parport_control);
  }
}

void set_hardware_rx_gain(void)
{
// bit0 to bit 2 for amplifier/bypass/-10 dB.
// bit0-bit2 = 6 => -10dB
// bit0-bit2 = 3 => 0dB
// bit0-bit2 = 5 => +10dB
//
// bit3 for 5 dB attenuator.
// bit3 = 0 => -5dB
// bit3 = 1 =>  0dB
if(diskread_flag >= 2)return;
if(ui.rx_addev_no == SDR14_DEVICE_CODE)
  {
  fg.gain_increment=10;
  fg.gain/=10;
  fg.gain*=10;
  if(fg.gain > 0)fg.gain=0;
  if(fg.gain<-30)fg.gain=-30;
  if(rx_hware_init_flag==0)sdr_att_counter++;
  return;
  }
if(ui.rx_addev_no == SDRIQ_DEVICE_CODE)
  {
  fg.gain_increment=1;
  if(fg.gain > 0)fg.gain=0;
  if(fg.gain<-36)fg.gain=-36;
  if(rx_hware_init_flag==0)sdr_att_counter++;
  return;
  }
if(ui.rx_addev_no == SDRIP_DEVICE_CODE)
  {
  fg.gain_increment=10;
  fg.gain/=10;
  fg.gain*=10;
  if(fg.gain > 0)fg.gain=0;
  if(fg.gain<-30)fg.gain=-30;
  if(rx_hware_init_flag==0)sdr_att_counter++;
  return;
  }
if(ui.rx_addev_no == PERSEUS_DEVICE_CODE)
  {
  fg.gain_increment=10;
  fg.gain/=10;
  fg.gain*=10;
  if(fg.gain > 0)fg.gain=0;
  if(fg.gain<-30)fg.gain=-30;
  if(rx_hware_init_flag==0)sdr_att_counter++;
  return;
  }
switch (ui.soundcard_radio)
  {
  case SOUNDCARD_RADIO_WSE:
  wse_rx_amp_control();
  break;
  }
}

void set_hardware_rx_frequency(void)
{
float t1;
int i;
if(diskread_flag >= 2)
  {
  sc[SC_WG_FQ_SCALE]++;
  return;
  }
if(rx_mode < MODE_TXTEST)users_set_band_no();
if(ui.rx_addev_no == SDR14_DEVICE_CODE ||
   ui.rx_addev_no == SDRIQ_DEVICE_CODE )
  {
  t1=fg.passband_center;
  fg.passband_direction=1;
  if(fg.passband_center > adjusted_sdr_clock)
    {
    i=fg.passband_center/adjusted_sdr_clock;
    t1=fg.passband_center-i*adjusted_sdr_clock;
    }
  if(t1 > 0.5*adjusted_sdr_clock)
    {
    t1=adjusted_sdr_clock-t1;
    fg.passband_direction=-1;
    }
  fg.passband_increment=.1;
  if(rx_hware_init_flag==0)sdr_nco_counter++;
  goto setfq_x;
  }
if(ui.rx_addev_no == SDRIP_DEVICE_CODE)
  {
  fg.passband_direction=1;
  fg.passband_increment=.1;
  if(rx_hware_init_flag==0)sdr_nco_counter++;
  goto setfq_x;
  }
if(ui.rx_addev_no == PERSEUS_DEVICE_CODE)
  {
  fg.passband_direction=1;
  fg.passband_increment=.1;
  if(rx_hware_init_flag==0)sdr_nco_counter++;
  goto setfq_x;
  }
switch (ui.soundcard_radio)
  {
  case SOUNDCARD_RADIO_WSE:
  wse_rx_freq_control();
  break;
    
#if LIBUSB_PRESENT == 1
  case SOUNDCARD_RADIO_SI570:
  si570_rx_freq_control();
  break;
#endif
  }
setfq_x:;
fft1_direction=fg.passband_direction;
check_filtercorr_direction();
}

